#include "app.hpp"
#include <Pt.h>
#include <new.h>

#include <phcpp/PhTrace.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>

CApp :: CApp()
{  tsWinSize.x = 1000;
   tsWinSize.y = 700;

   pcTitle = strdup("PhCpp Test App");

   pcCurrentFile = strdup("phcpptest.cpp");
}

virtual CApp :: ~CApp()
{  sprintf(caBuff, "stackavail:  %u\n", stackavail());
   PhTrace(caBuff);

   sprintf(caBuff, "stackavail:  %u\n", stackavail());
   PhTrace(caBuff);

   if(pcTitle)
     free(pcTitle);

   sprintf(caBuff, "stackavail:  %u\n", stackavail());
   PhTrace(caBuff);

   if(pobjWndManager)
     delete(pobjWndManager);

   if(pwndMain)
     delete(pwndMain);
 
   sprintf(caBuff, "stackavail:  %u\n", stackavail());
   PhTrace(caBuff);

   free(pcCurrentFile);

   sprintf(caBuff, "stackavail:  %u\n", stackavail());
   PhTrace(caBuff);
}

CApp :: Init(int argc, char * argv[])
{  argc = argc, argv = argv;

   PtInit (NULL);
   PhTraceInit(); 

   PhTrace("Entering danger zone.\n");

   char caBuff[20];
   pwndMain = new CWindow(NULL, 0, NULL);
   sprintf(caBuff, "%x\n", pwndMain);
   PhTrace(caBuff);

   pwndMain->SetResource(Pt_ARG_DIM, (long)&tsWinSize, 0L); 
   sprintf(caBuff, "%x\n", pwndMain);
   PhTrace(caBuff);
   pwndMain->SetResource(Pt_ARG_WINDOW_TITLE, (long)pcTitle, 0L);
   pwndMain->SetResource(Pt_ARG_FILL_COLOR, Pg_GREY, 0L);
   pwndMain->SetResource(Pt_ARG_FLAGS, Pt_GETS_FOCUS, Pt_GETS_FOCUS);
   pwndMain->SetResource(Pt_ARG_WINDOW_NOTIFY_FLAGS, ~Pt_SET, Ph_WM_RESIZE | Ph_WM_MOVE | Ph_WM_CLOSE);
   pwndMain->Realize();

   objMenuCallbacks.InitMenuCallbacks();

   pobjWndManager = new CWindowCallback(pwndMain, Pt_CB_WINDOW, NULL);
}

CApp :: Run()
{  PhTrace("Entering PtMainLoop\n");

   PtMainLoop();
}

CWindow * CApp :: ReturnMainWindowPtr()
{  return(pwndMain);
}
