#include <phcpp/PhTrace.h>
#include <phcpp/tty.hpp>
#include <phcpp/scrollbar.hpp>

#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "makedlg.hpp"

extern "C"
{  int fnOnOkButtonDownWrapper(PtWidget_t * pWgt, void * pvData, PtCallbackInfo_t * ptsInfo);
   int fnOnDefaultButtonDownWrapper(PtWidget_t * pWgt, void * pvData, PtCallbackInfo_t * ptsInfo);
}

int CMakeDlg :: DoModal(short nType)
{  CScrollbar * pobjScrollbar = NULL;
   CTty * pobjTty = NULL;
   PhArea_t tsTtyArea;
   PhArea_t tsButtonArea;
   PhArea_t tsScrollArea;
   int iReturnCode = 0;
   int iHoldCount = 0;
   PtWidget_t * pwgtTop;
   
   pobjOkButton = new CButton(this->pwgt, 0, NULL);

   tsTtyArea.pos.x = 10;
   tsTtyArea.pos.y = 10;
   tsTtyArea.size.w = 780;
   tsTtyArea.size.h = 500;

   tsButtonArea.size.w = 50;
   tsButtonArea.size.h = 20;
   tsButtonArea.pos.x = 375;
   tsButtonArea.pos.y = 550;

   tsScrollArea.pos.x = 792;
   tsScrollArea.pos.y = 10;
   tsScrollArea.size.w = 10;
   tsScrollArea.size.h = 500;

   pobjTty = new CTty(this->pwgt, 0, NULL);
   pobjTty->SetResource(Pt_ARG_AREA, (long)&tsTtyArea, 0L); 
   pobjTty->SetResource(Pt_ARG_TTY_PSEUDO, (long)"/dev", 0L);

   switch(nType)
   {  case BUILD_FILE:  pobjTty->SetResource(Pt_ARG_TTY_CMD, (long)"cc -g -c TestDir/testcpp.c", 0L);
			break;
     
      case BUILD_APP:   pobjTty->SetResource(Pt_ARG_TTY_CMD, (long)"make -f TestDir/Makefile", 0L);
			break;
   }
   
   pobjTty->SetResource(Pt_ARG_TERM_SCRLBK_LIMIT, 100L, 0L);

   pobjOkButton->SetResource(Pt_ARG_AREA, (long)&tsButtonArea, 0L);
   pobjOkButton->SetResource(Pt_ARG_TEXT_STRING, (long)"OK", 0L);
   pobjOkButton->AddCallback(Pt_CB_ACTIVATE, (void (*)(void))fnOnOkButtonDownWrapper, NULL);

   pobjScrollbar = new CScrollbar(this->pwgt, 0, NULL);
   pobjScrollbar->SetResource(Pt_ARG_AREA, (long)&tsScrollArea, 0L);
   pobjScrollbar->SetResource(Pt_ARG_MINIMUM, 0L, 0L);
   pobjScrollbar->SetResource(Pt_ARG_MAXIMUM, 100, 0L);
   pobjScrollbar->SetResource(Pt_ARG_INCREMENT, 500/100, 0L);
   pobjOnScroll = new COnScrollCB(pobjScrollbar, Pt_CB_SCROLL_MOVE, pobjTty);

   bCallbackAttached = TRUE;
     
   pwgtTop = BlockApp();

   Realize();

   bContinueModal = TRUE;

   iHoldCount = PtModalStart();

   while(bContinueModal)
     PtProcessEvent();

   PtModalEnd(iHoldCount);

   UnBlockApp();

   delete pobjOnScroll;
   delete pobjScrollbar;
   delete pobjTty;
   delete pobjOkButton;

   if(pwgtReturn == (*pobjOkButton))
     iReturnCode = IDOK;
   else
     iReturnCode = 0;

   pwgtReturn = NULL;

   return(iReturnCode);
}

int CMakeDlg :: OnOkButtonDown(PtWidget_t * pWgt, void * pvData, PtCallbackInfo_t * ptsInfo)
{  if(bCallbackAttached)
     RemoveCallback(Pt_CB_ACTIVATE, (void (* )(void))fnOnOkButtonDownWrapper, pvData);

   bCallbackAttached = FALSE;
   Unrealize();

   if(bBlocking)
     bContinueModal = FALSE;

   pwgtReturn = pWgt;

   return(Pt_CONTINUE);
}

int fnOnOkButtonDownWrapper(PtWidget_t * pWgt, void * pvData, PtCallbackInfo_t * ptsInfo)
{  CMakeDlg * pobj; 

   pobj = *((CMakeDlg **)PtFindWidgetData(PtWidgetParent(pWgt), (Pt_widget_class_ref *)fnOnDefaultButtonDownWrapper, Pt_DIALOG_X1_RESOURCES, NULL));
   return(pobj->OnOkButtonDown(pWgt, pvData, ptsInfo));
}
