#include <new.h>
#include <sys/types.h>
#include <unistd.h>
#include <process.h>
#include <malloc.h>

#include <phcpp/PhTrace.h>
#include "app.hpp"
#include "menucbs.hpp"

extern CApp * pobjAppInstance;

CMenuCallbacks :: CMenuCallbacks()
{  pobjFE_CB = NULL;
   pobjBC_CB = NULL;
   pobjBA_CB = NULL;
   pobjAD_CB = NULL;
   bInited = FALSE;

   pcTextString[0] = strdup("File");
   pcTextString[1] = strdup("Build");
   pcTextString[2] = strdup("Help");

   pcFileTextString[0] = strdup("New");
   pcFileTextString[1] = strdup("Open");
   pcFileTextString[2] = strdup("Close");
   pcFileTextString[3] = strdup("Save");
   pcFileTextString[4] = strdup("Save As");
   pcFileTextString[5] = strdup("Exit");

   pcBuildTextString[0] = strdup("Generate Dependencies");
   pcBuildTextString[1] = strdup("Build .cpp");
   pcBuildTextString[2] = strdup("Make");
   pcBuildTextString[3] = strdup("Make All");

   pcHelpTextString[0] = strdup("Index");
   pcHelpTextString[1] = strdup("Search for ...");
   pcHelpTextString[2] = strdup("Tutorials");
   pcHelpTextString[3] = strdup("About");

   PhPoint_t tsWinSize = {1000, 700};

   tsBarSize.x = tsWinSize.x;
   tsBarSize.y = 20;

   tsButtonSize.x = 15;
   tsButtonSize.y = 15;

   tsButtonPos.x = 0;
   tsButtonPos.y = 2;
   tsMenuSize.x = 40;
   tsMenuSize.y = 60;
}

virtual CMenuCallbacks :: ~CMenuCallbacks()
{  short n = 0;

   if(pobjFE_CB)
     delete pobjFE_CB;

   if(pobjBC_CB)
     delete pobjBC_CB;

   if(pobjBA_CB)
     delete pobjBA_CB;

   if(pobjAD_CB)
     delete pobjAD_CB;

   for(n = 0; n < MAX_FILE_MENU_BUTTONS; n++)
     if(pobjFileSubMenuButtons[n])
     {  delete pobjFileSubMenuButtons[n];
        free(pcFileTextString[n]);
     }

   sprintf(caBuff, "stackavail:  %u\n", stackavail());
   PhTrace(caBuff);

   sprintf(caBuff, "stackavail:  %u\n", stackavail());
   PhTrace(caBuff);

   sprintf(caBuff, "stackavail:  %u\n", stackavail());
   PhTrace(caBuff);

   for(n = 0; n < MAX_BUILD_MENU_BUTTONS; n++)
     if(pobjBuildSubMenuButtons[n])
     {  delete pobjBuildSubMenuButtons[n];
        free(pcBuildTextString[n]);
     }

   sprintf(caBuff, "stackavail:  %u\n", stackavail());
   PhTrace(caBuff);

   for(n = 0; n < MAX_HELP_MENU_BUTTONS; n++)
     if(pobjHelpSubMenuButtons[n])
     {  delete pobjHelpSubMenuButtons[n];
        free(pcHelpTextString[n]);
     }

   sprintf(caBuff, "stackavail:  %u\n", stackavail());
   PhTrace(caBuff);

   for(n = 0; n < MAX_MENU_BUTTONS; n++)
   {  delete pobjMenuButton[n];
      delete pobjMenu[n];
   }

   sprintf(caBuff, "stackavail:  %u\n", stackavail());
   PhTrace(caBuff);

   free(pcTextString[0]);
   free(pcTextString[1]);
   free(pcTextString[2]);

   if(pobjMenuBar)
     delete pobjMenuBar;

   sprintf(caBuff, "stackavail:  %u\n", stackavail());
   PhTrace(caBuff);

   if(pdlgAbout)
     delete(pdlgAbout);

   if(pdlgMake)
     delete(pdlgMake);
}

CMenuCallbacks :: InitMenuCallbacks()
{  short n = 0;

   if(!bInited) 
   {  pdlgAbout = new CDialog(*(pobjAppInstance->ReturnMainWindowPtr()), 0, NULL);
      pdlgMake = new CMakeDlg(*(pobjAppInstance->ReturnMainWindowPtr()), 0, NULL);

      bInited = TRUE;

      pobjMenuBar = new CMenuBar(*(pobjAppInstance->ReturnMainWindowPtr()), 0, NULL);
      pobjMenuBar->SetResource(Pt_ARG_DIM, (long)&tsBarSize, 0L);
      pobjMenuBar->Realize();

      for(n = 0; n < MAX_MENU_BUTTONS; n++)
      {  pobjMenuButton[n] = new CMenuButton(*pobjMenuBar, 0, NULL);
         pobjMenuButton[n]->SetResource(Pt_ARG_DIM, (long)&tsButtonSize, 0L);
         pobjMenuButton[n]->SetResource(Pt_ARG_TEXT_STRING, (long)pcTextString[n], 0L);
         tsButtonPos.x = n * 20;
         pobjMenuButton[n]->SetResource(Pt_ARG_POS, (long)&tsButtonPos, 0L);
         pobjMenuButton[n]->Realize();

         if((pobjMenu[n] = new CMenu(*(pobjMenuButton[n]), 0, NULL)) == NULL)
           PhTrace("Menu == NULL");
      }

      for(n = 0; n < MAX_FILE_MENU_BUTTONS; n++)
      {  if((pobjFileSubMenuButtons[n] = new CMenuButton(*(pobjMenu[IDM_FILE]), 0, NULL)) == NULL)
           PhTrace("MenuButton == NULL\n");

         sprintf(caBuff, "%x\n", pobjMenu[IDM_FILE]);
         PhTrace(caBuff);

         sprintf(caBuff, "%x\n", pobjFileSubMenuButtons[n]);
         PhTrace(caBuff);

         pobjFileSubMenuButtons[n]->SetResource(Pt_ARG_TEXT_STRING, (long)pcFileTextString[n], 0L);
      }

      for(n = 0; n < MAX_BUILD_MENU_BUTTONS; n++)
      {  pobjBuildSubMenuButtons[n] = new CMenuButton(*(pobjMenu[IDM_BUILD]), 0, NULL);
         pobjBuildSubMenuButtons[n]->SetResource(Pt_ARG_TEXT_STRING, (long)pcBuildTextString[n], 0L);
      }

      for(n = 0; n < MAX_HELP_MENU_BUTTONS; n++)
      {  pobjHelpSubMenuButtons[n] = new CMenuButton(*(pobjMenu[IDM_HELP]), 0, NULL);
         pobjHelpSubMenuButtons[n]->SetResource(Pt_ARG_TEXT_STRING, (long)pcHelpTextString[n], 0L);
      }

      pobjFE_CB = new CFileExitCallback(pobjFileSubMenuButtons[IDB_FILE_EXIT], Pt_CB_ACTIVATE, NULL);
      pobjBC_CB = new CBuildCppCallback(pobjBuildSubMenuButtons[IDB_BUILD_CPP], Pt_CB_ACTIVATE, pdlgMake);
      pobjBA_CB = new CBuildAppCallback(pobjBuildSubMenuButtons[IDB_BUILD_MAKE], Pt_CB_ACTIVATE, pdlgMake);
      pobjAD_CB = new CAboutDialogCallback(pobjHelpSubMenuButtons[IDB_HELP_ABOUT], Pt_CB_ACTIVATE, pdlgAbout);
   }
}

const CDialog * CMenuCallbacks :: ReturnAboutDlgPtr()
{  return((const CDialog *)pdlgAbout);
}

const CMakeDlg * CMenuCallbacks :: ReturnMakeDlgPtr()
{  return((const CMakeDlg *)pdlgMake);
}
