#ifndef __CMENUCALLBACKS_HPP_
#define __CMENUCALLBACKS_HPP_

#include <phcpp/dialog.hpp>
#include "Callbacks/fe.hpp"
#include "Callbacks/bc.hpp"
#include "Callbacks/ba.hpp"
#include "Callbacks/ad.hpp"

#include "makedlg.hpp" 

#define MAX_MENU_BUTTONS 3 
#define MAX_FILE_MENU_BUTTONS 6
#define MAX_BUILD_MENU_BUTTONS 4
#define MAX_HELP_MENU_BUTTONS 4

#define IDM_FILE 0
#define IDM_BUILD 1 
#define IDM_HELP 2
#define IDB_HELP_ABOUT 3 
#define IDB_FILE_EXIT 5 
#define IDB_BUILD_CPP 1
#define IDB_BUILD_MAKE 2

class CMenuCallbacks
{	private:
		CDialog * pdlgAbout;
		BOOL bInited;
                CMakeDlg * pdlgMake;

                char caBuff[20];
                char * pcTextString[MAX_MENU_BUTTONS];
                char * pcFileTextString[MAX_FILE_MENU_BUTTONS];
                char * pcBuildTextString[MAX_BUILD_MENU_BUTTONS];
                char * pcHelpTextString[MAX_HELP_MENU_BUTTONS];

                CMenuButton * pobjMenuButton[MAX_MENU_BUTTONS];
                CMenuButton * pobjFileSubMenuButtons[MAX_FILE_MENU_BUTTONS];
                CMenuButton * pobjBuildSubMenuButtons[MAX_BUILD_MENU_BUTTONS];
                CMenuButton * pobjHelpSubMenuButtons[MAX_HELP_MENU_BUTTONS];

                CMenu * pobjMenu[MAX_MENU_BUTTONS];
                CMenuBar * pobjMenuBar;

                PhPoint_t tsBarSize;
                PhPoint_t tsButtonSize;
                PhPoint_t tsButtonPos;
                PhPoint_t tsMenuSize;

		CFileExitCallback * pobjFE_CB;
		CBuildCppCallback * pobjBC_CB;
		CBuildAppCallback * pobjBA_CB;
		CAboutDialogCallback * pobjAD_CB;

  	public:
		CMenuCallbacks();
		virtual ~CMenuCallbacks();
		InitMenuCallbacks();
		const CDialog * ReturnAboutDlgPtr();
		const CMakeDlg * ReturnMakeDlgPtr();
};
#endif
