#ifndef _CDBASE_HPP_
#define _CDBASE_HPP_

#include <Ap.h>
#include <Pt.h>
#include <phcpp/defs.hpp>

class CWgtDBase
{	private:
		ApDBase_t * ptsDBase;

  	public:
		CWgtDBase() 
		{  ptsDBase = NULL;
		};

		inline CWgtDBase(ApEventLink_t * ptsLinkCallback)
		{  if((ptsDBase = ApOpenDBase(ptsLinkCallback)) == NULL)
		     PhTrace("CWgtDBase :: OpenDBase() failed.\n");
		}

		inline CWgtDBase(char * pcPath)
		{  if((ptsDBase = ApOpenDBaseFile(pcPath)) == NULL)
		     PhTrace("CWgtDBase :: OpenDBaseFile() failed.\n");
		}

		inline virtual ~CWgtDBase()
		{  if(ptsDBase)
			 ApCloseDBase(ptsDBase);
		}

		inline BOOL Open(char * pcPath)
		{  if((ptsDBase = ApOpenDBaseFile(pcPath)) == NULL)
			 return(FALSE);
		   else
			 return(TRUE);	 
		}

		inline BOOL Open(ApEventLink_t * ptsLinkCallback)
		{  if((ptsDBase = ApOpenDBase(ptsLinkCallback)) == NULL)
		     return(FALSE);
		   else
			 return(TRUE);
		}

		inline BOOL Close()
		{  return(ApCloseDBase(ptsDBase));
		}

		inline BOOL CopyWidget(ApDBase_t * ptsFromDBase, char * pcFromName, char * pcToName)
		{  return(ApCopyWidget(ptsFromDBase, pcFromName, ptsDBase, pcToName));
		}

		inline PtWidget_t * CreateWidget(char * pcWgtName, int iX, int iY, int iNumArgs, PtArg_t * ptsArgs)
		{  return(ApCreateWidget(ptsDBase, pcWgtName, iX, iY, iNumArgs, ptsArgs));
		}

		inline PtWidget_t * CreateWidgetFamily(char * pcWgtName, int iX, int iY, int iNumArgs, PtArg_t * ptsArgs)
		{  return(ApCreateWidgetFamily(ptsDBase, pcWgtName, iX, iY, iNumArgs, ptsArgs));
		}

		inline BOOL DeleteWidget(char * pcWgtName)
		{  return(ApDeleteWidget(ptsDBase, pcWgtName));
		}

		inline ApBitmap_t * GetBitmapRes(char * pcWgtName)
		{  return(ApGetBitmapRes(ptsDBase, pcWgtName));
		}

		inline PhImage_t * GetImageRes(char * pcWgtName)
		{  return(ApGetImageRes(ptsDBase, pcWgtName));
		}

		inline char * GetTextRes(char * pcWgtName)
		{  return(ApGetTextRes(ptsDBase, pcWgtName));
		}

		inline BOOL SaveDBaseFile(char * pcPath)
		{  return(ApSaveDBaseFile(ptsDBase, pcPath));
		}
};
#endif
