#ifndef __CDIALOG_HPP_
#define __CDIALOG_HPP_

#include <phcpp/window.hpp>
#include <phcpp/button.hpp>
#include <phcpp/label.hpp>

// 97/09/08 - Severe overhaul.
//	      InitDialog() function is no longer needed.
//	      Made the following private:
//			pcButtonText, pcLabelText
//			pobjDefaultButton, pobjDefaultLabel
//	      Removed several convenience functions for
//	      extern "C" callbacks.
//	      Added callback wrapper to call member method.
//	      Removed destructor.
// 97/09/18 - Fixed bug in DoModalless().

#define IDOK 0
#define Pt_DIALOG_X1_RESOURCES 500

// Use to key off of.
extern "C"
{  int fnOnDefaultButtonDownWrapper(PtWidget_t * pWgt, void * pvData, PtCallbackInfo_t * ptsInfo);
}

class CDialog : public CWindow
{	private:
		CButton * pobjDefaultButton;
		CLabel * pobjDefaultLabel;
		char * pcButtonText;
		char * pcLabelText;

	protected:
		BOOL bCallbackAttached;
		BOOL bBlocking;
		BOOL bContinueModal;
		PtWidget_t * pwgtReturn;

	protected:
		PtWidget_t * BlockApp();	// Returns to top most PtWidget_t * in hierarchy.
		UnBlockApp();

	public:
		CDialog() : CWindow() {};
		CDialog(const PtWidget_t * pobjParent, UINT uiNumArgs, PtArg_t * ptsArgs);
		int DoModal();
		BOOL DoModalless();
		BOOL ChangeButtonText(char * pcButtonText);
		BOOL ChangeLabelText(char * pcLabelText);
		int OnDefaultButtonDown(PtWidget_t * pWgt, void * pvData, PtCallbackInfo_t * ptsInfo);
};
#endif
