#ifndef __CFILESEL_HPP_
#define __CFILESEL_HPP_

#include <photon/PtFileSel.h>
#include <phcpp/gentree.hpp>

class CFileSel : public CGenTree
{	protected:

	public:
		CFileSel() {  pwgt = NULL; pulClassRef = NULL;};
		CFileSel(const PtWidget_t * pobjParent, UINT uiNumArgs, PtArg_t * pArgs);

		inline AddAfter(PtFileSelItem_t * ptsItem, PtFileSelItem_t * ptsBrother)
		{  PtFSAddAfter(pwgt, ptsItem, ptsBrother);
		}

		inline AddFirst(PtFileSelItem_t * ptsItem, PtFileSelItem_t * ptsParent)
		{  PtFSAddFirst(pwgt, ptsItem, ptsParent);
		}

		inline PtFileSelItem_t ** AllItems(PtFileSelItem_t ** pptsBuffer)
		{  return(PtFSAllItems(pwgt, pptsBuffer));
		}

		inline PtFileSelItem_t * AllocItem(int iType, char * pcInfo)
		{  return(PtFSAllocItem(pwgt, iType, pcInfo));
		}

		inline ClearSelection()
		{  PtFSClearSelection(pwgt);
		}

		inline DamageItem(PtFileSelItem_t * ptsItem)
		{  PtFSDamageItem(pwgt, ptsItem);
		}

		inline ExpandParents(PtFileSelItem_t * ptsItem, PhEvent_t * ptsEvent)
		{  PtFSExpandParents(pwgt, ptsItem, ptsEvent);
		}

		inline Select(PtFileSelItem_t * ptsItem)
		{  PtFSSelect(pwgt, ptsItem);
		}

		inline FolderCollapse(PtFileSelItem_t * ptsItem, PhEvent_t * ptsEvent)
		{  PtFSFolderCollapse(pwgt, ptsItem, ptsEvent);
		}

		inline int FolderExpand(PtFileSelItem_t * ptsItem, PhEvent_t * ptsEvent)
		{  return(PtFSFolderExpand(pwgt, ptsItem, ptsEvent));
		}

		inline FreeAllItems()
		{  PtFSFreeAllItems(pwgt);
		}

		inline FreeItems(PtFileSelItem_t * ptsItem)
		{  PtFSFreeItems(ptsItem);
		}

		inline PtFileSelItem_t * GetCurrent()
		{  return(PtFSGetCurrent(pwgt));
		}

		inline USHORT * GetSelIndices(USHORT * pusBuffer)
		{  return(PtFSGetSelIndexes(pwgt, pusBuffer));
		}

		inline Goto(PtFileSelItem_t * ptsItem)
		{  PtFSGoto(pwgt, ptsItem);
		}

		inline int ItemIndex(PtFileSelItem_t * ptsItem)
		{  return(PtFSItemIndex(pwgt, ptsItem));
		}

		inline int SetSelIndices(USHORT * pusBuffer, int iCount)
		{  return(PtFSSetSelIndexes(pwgt, pusBuffer, iCount));
		}

		inline Show(PtFileSelItem_t * ptsItem)
		{  PtFSShow(pwgt, ptsItem);
		}

		inline Unselect(PtFileSelItem_t * ptsItem)
		{  PtFSUnselect(pwgt, ptsItem);
		}

		inline UnselectNonBrothers(PtFileSelItem_t * ptsItem)
		{  PtFSUnselectNonBrothers(pwgt, ptsItem);
		}

		inline PtFileSelItem_t * RemoveChildren(PtFileSelItem_t * ptsItem)
		{  return((PtFileSelItem_t *) PtGenTreeRemoveChildren((PtGenTreeItem_t *) ptsItem));
		}

		inline RemoveItem(PtFileSelItem_t * ptsItem)
		{  PtFSRemoveItem(pwgt, ptsItem);
		}

		inline RemoveList(PtFileSelItem_t * ptsFirst)
		{  PtFSRemoveList(pwgt, ptsFirst);
		}

		inline PtFileSelItem_t * RootItem()
		{  return(PtFSRootItem(pwgt));
		}

		inline PtFileSelItem_t ** SelectedItems(PtFileSelItem_t ** pptsBuffer)
		{  return(PtFSSelectedItems(pwgt, pptsBuffer));
		}
};
#endif
