#ifndef __CLIST_HPP_
#define __CLIST_HPP_

#include <phcpp/gentree.hpp>
#include <phcpp/defs.hpp>
#include <photon/PtList.h>

class CList : public CGenTree
{
	public:
		CList() {  pwgt = NULL; pulClassRef = NULL;};
		CList(const PtWidget_t * pobjParent, UINT uiNumArgs, PtArg_t * pArgs);

		inline BOOL AddItems(char ** ppcItems, int iItemCount, UINT uiPosition)
		{  return(PtListAddItems(pwgt, ppcItems, iItemCount, uiPosition));
		}

		inline BOOL DeleteAllItems()
		{  return(PtListDeleteAllItems(pwgt));
		}

		inline BOOL DeleteItems(char ** ppcItems, int iItemCount)
		{  return(PtListDeleteItems(pwgt, ppcItems, iItemCount));
		}

		inline BOOL DeleteItemPos(int iItemCount, int iPosition)
		{  return(PtListDeleteItemPos(pwgt, iItemCount, iPosition));
		}

		inline BOOL DeletePositions(int * piPosList, int iPosCount)
		{  return(PtListDeletePositions(pwgt, piPosList, iPosCount));
		}

		inline BOOL ItemExists(char * pcItem)
		{  return(PtListItemExists(pwgt, pcItem));
		}

		inline int ItemPos(char * pcItem)
		{  return(PtListItemPos(pwgt, pcItem));
		}

		inline BOOL ReplaceItemPos(char ** ppcNewItems, int iItemCount, int iPosition)
		{  return(PtListReplaceItemPos(pwgt, ppcNewItems, iItemCount, iPosition));
		}

		inline BOOL ReplaceItems(char ** ppcOldItems, char ** ppcNewItems, int iItemCount)
		{  return(PtListReplaceItems(pwgt, ppcOldItems, ppcNewItems, iItemCount));
		}
};
#endif
