#ifndef _CSOCKET_HPP_
#define _CSOCKET_HPP_

#include <phcpp/defs.hpp>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

class CSocket
{  
   private:
   	int m_wSock;
   	int m_iSockDomain;

   public:
   	CSocket();
	CSocket(int wSock, int iSockDomain);

   	virtual inline ~CSocket() 
	{  if(m_wSock)
		 Close();
	};

   	BOOL Create(int iDomain, int iType, int iProtocol);
   	int Connect(void * ptsSockAddr);
	int Close();
   	int Bind(void * ptsSockAddr);
   	int Write(void * pvData, short nNumBytes);
   	int Write(BYTE * pbyData);
   	int Accept(void * ptsSockAddr);
	int Read(void * pvBuffer, short nNumBytes);

	inline int Listen(int iBackLog)
	{  return(listen(m_wSock, iBackLog));
	}

	inline operator int()
	{  return(m_wSock);
	}
};
#endif
