// Photon 1.2 Class

#ifndef __CTREE_HPP_
#define __CTREE_HPP_

#include <phcpp/gentree.hpp>
#include <phcpp/defs.hpp>
#include <photon/PtTree.h>

class CTree : public CGenTree
{
	public:
		CTree() {  pwgt = NULL; pulClassRef = NULL;};
		CTree(const PtWidget_t * pobjParent, UINT uiNumArgs, PtArg_t * pArgs);

		inline AddAfter(PtTreeItem_t * ptsItem, PtTreeItem_t * ptsBrother)
		{  PtTreeAddAfter(pwgt, ptsItem, ptsBrother);
		}

		inline CTree :: AddFirst(PtTreeItem_t * ptsItem, PtTreeItem_t * ptsParent)
		{  PtTreeAddFirst(pwgt, ptsItem, ptsParent);
		}

		inline int AddImages(PhImage_t const * pktsImages, int i)
		{  return(PtTreeAddImages(pwgt, pktsImages, i));
		}

		inline PtTreeItem_t ** AllItems(PtTreeItem_t ** pptsBuffer)
		{  return(PtTreeAllItems(pwgt, pptsBuffer));
		}

		inline PtTreeItem_t * AllocItem(const char * pksz, short nSelImg, short nUnselImg)
		{  return(PtTreeAllocItem(pwgt, pksz, nSelImg, nUnselImg));
		}

		inline ClearSelection()
		{  PtTreeClearSelection(pwgt);
		}

		inline Collapse(PtTreeItem_t * ptsItem, PhEvent_t * ptsEvent)
		{  PtTreeCollapse(pwgt, ptsItem, ptsEvent);
		}

		inline int Expand(PtTreeItem_t * ptsItem, PhEvent_t * ptsEvent)
		{  return(PtTreeExpand(pwgt, ptsItem, ptsEvent));
		}

		inline FreeAllItems()
		{  PtTreeFreeAllItems(pwgt);
		}

		inline FreeItems(PtTreeItem_t * ptsItem)
		{  PtTreeFreeItems(ptsItem);
		}

		inline PtTreeItem_t * GetCurrent()
		{  return(PtTreeGetCurrent(pwgt));
		}

		inline USHORT * GetSelIndices(USHORT * pnBuffer)
		{  return(PtTreeGetSelIndexes(pwgt, pnBuffer));
		}

		inline Goto(PtTreeItem_t * ptsItem)
		{  PtTreeGoto(pwgt, ptsItem);
		}

		inline int ItemIndex(PtTreeItem_t const * pktsItem)
		{  return(PtTreeItemIndex(pwgt, pktsItem));
		}

		inline PtTreeItem_t * ModifyItem(PtTreeItem_t * ptsItem, const char * pksz, short nSelImg, short nUnselImg)
		{  return(PtTreeModifyItem(pwgt, ptsItem, pksz, nSelImg, nUnselImg));
		}

		inline RemoveItem(PtTreeItem_t * ptsItem)
		{  PtTreeRemoveItem(pwgt, ptsItem);
		}

		inline RemoveList(PtTreeItem_t * ptsFirst)
		{  PtTreeRemoveList(pwgt, ptsFirst);
		}

		inline PtTreeItem_t * RootItem()
		{  return(PtTreeRootItem(pwgt));
		}

		inline Select(PtTreeItem_t * ptsItem)
		{  PtTreeSelect(pwgt, ptsItem); 
		}

		inline PtTreeItem_t ** SelectedItems(PtTreeItem_t ** pptsBuffer)
		{  return(PtTreeSelectedItems(pwgt, pptsBuffer));
		}

		inline int SetSelIndices(const USHORT * pkusBuffer, int iCount)
		{  return(PtTreeSetSelIndexes(pwgt, pkusBuffer, iCount));
		}

		inline Show(PtTreeItem_t * ptsItem)
		{  PtTreeShow(pwgt, ptsItem);
		}

		inline Unselect(PtTreeItem_t * ptsItem)
		{  PtTreeUnselect(pwgt, ptsItem);
		}

		inline UnselectNonBrothers(PtTreeItem_t * ptsItem)
		{  PtTreeUnselectNonBrothers(pwgt, ptsItem);
		}
};
#endif
